import assert from 'node:assert/strict'
import { metaltest, consolereporter } from './index.js'
import { stackParser } from "./stackparser.js"

const test = metaltest('Stack parser')

test('Diff', () => {
  try {
    assert.deepEqual({ name: 'Name' }, { name: 'Name2' })
  }
  catch (e) {
    const stack = stackParser(e.stack)
    assert.ok(stack.diff.includes("name: 'Name'"))
    assert.ok(stack.diff.includes("name: 'Name2'"))
    assert.ok(stack.where.includes('stackparser.test.js'))
  }
})

await test.run(consolereporter())
